// diag.cpp : Defines the entry point for the console application.
//

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef short           sara_int;
typedef long            sara_long;
typedef unsigned long   sara_ulong;

sara_int letobe2(sara_int);
sara_long letobe4(sara_long);

struct index_sig {
	char name[101];
	sara_int nelts __attribute__ ((aligned(2)));
	sara_int natts;
	sara_int npos;
	sara_ulong ntexts;
	sara_int nhash, nhashsig;
	sara_int hashshift, hashlast;
	sara_int maxiloc;
} __attribute__ ((packed));		
	

int main(int argc, char* argv[])
{
	FILE* f1; FILE* f2; FILE* f3; struct index_sig is;
	f1=fopen("diag.txt","w");
	fprintf(f1,"sizeof sara_int=%d\n",sizeof(sara_int));
	fprintf(f1,"sizeof sara_long=%d\n",sizeof(sara_long));
	fprintf(f1,"sizeof sara_ulong=%d\n",sizeof(sara_ulong));
	fprintf(f1,"sizeof index_sig=%d\n",sizeof(struct index_sig));
	fprintf(f1,"Recorded index sig in diag.sig\n");
	f2=fopen("diag.sig","w");
	strcpy(is.name,"diag");
	is.nelts=2;
	is.natts=3;
	is.npos=5;
	is.ntexts=7;
	is.nhash=13;
	is.nhashsig=17;
	is.hashshift=19;
	is.hashlast=31;
	is.maxiloc=61;
	fwrite(&is,sizeof(is),1,f2);
	fclose(f2);
	printf("Wrote files diag.txt and diag.sig");
	f3=fopen("diag0.sig","r");
	if (f3==NULL) fprintf(f1,"Cannot find diag0.sig\n");
	else {
		fread(&is,sizeof(is),1,f3);
		fprintf(f1,"Readback: %d %d %d %d %d %d %d %d %d\n",
			letobe2(is.nelts),letobe2(is.natts),letobe2(is.npos),letobe4(is.ntexts),letobe2(is.nhash),
			letobe2(is.nhashsig),letobe2(is.hashshift),letobe2(is.hashlast),letobe2(is.maxiloc));
		fclose(f3);
	}
	fclose(f1);
	return 0;
}

sara_int letobe2(sara_int x)
{
	return ((x & 0xff) << 8) | ((x >> 8) & 0xff);
}

sara_long letobe4(sara_long x)
{
	return (letobe2((sara_int) (x & 0xffff)) << 16) | (letobe2((sara_int) (x >> 16)) & 0xffff);
}
